Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.amazonaws.services.sns
Class AmazonSNSClient

    java.lang.Object
      com.amazonaws.AmazonWebServiceClient
          com.amazonaws.services.sns.AmazonSNSClient

All Implemented Interfaces:
  AmazonSNS

Direct Known Subclasses:
  AmazonSNSAsyncClient

    public class AmazonSNSClient

extends AmazonWebServiceClient
implements AmazonSNS

Client for accessing AmazonSNS. All service calls made using this client are blocking, and will not return until the service call completes.

Amazon Simple Notification Service

Constructor Summary
`AmazonSNSClient(AWSCredentials awsCredentials)` Constructs a new client to invoke service methods on AmazonSNS using the specified AWS account credentials.
`AmazonSNSClient(AWSCredentials awsCredentials, ClientConfiguration clientConfiguration)` Constructs a new client to invoke service methods on AmazonSNS using the specified AWS account credentials and client configuration options.

Method Summary
`void` | `addPermission(AddPermissionRequest addPermissionRequest)` The AddPermission action adds a statement to a topic's access control policy, granting access for the specified AWS accounts to the specified actions.
`ConfirmSubscriptionResult` | `confirmSubscription(ConfirmSubscriptionRequest confirmSubscriptionRequest)` The ConfirmSubscription action verifies an endpoint owner's intent to receive messages by validating the token sent to the endpoint by an earlier Subscribe action.
`CreateTopicResult` | `createTopic(CreateTopicRequest createTopicRequest)` The CreateTopic action creates a topic to which notifications can be published.
`void` | `deleteTopic(DeleteTopicRequest deleteTopicRequest)` The DeleteTopic action deletes a topic and all its subscriptions.
`GetTopicAttributesResult` | `getTopicAttributes(GetTopicAttributesRequest getTopicAttributesRequest)` The GetTopicAttribtues action returns all of the properties of a topic customers have created.
`ListSubscriptionsResult` | `listSubscriptions()` The ListSubscriptions action returns a list of the requester's subscriptions.
`ListSubscriptionsResult` | `listSubscriptions(ListSubscriptionsRequest listSubscriptionsRequest)` The ListSubscriptions action returns a list of the requester's subscriptions.
`ListSubscriptionsByTopicResult` | `listSubscriptionsByTopic(ListSubscriptionsByTopicRequest listSubscriptionsByTopicRequest)` The ListSubscriptionsByTopic action returns a list of the subscriptions to a specific topic.
`ListTopicsResult` | `listTopics()` The ListTopics action returns a list of the requester's topics.
`ListTopicsResult` | `listTopics(ListTopicsRequest listTopicsRequest)` The ListTopics action returns a list of the requester's topics.
`PublishResult` | `publish(PublishRequest publishRequest)` The Publish action sends a message to all of a topic's subscribed endpoints.
`void` | `removePermission(RemovePermissionRequest removePermissionRequest)` The RemovePermission action removes a statement from a topic's access control policy.
`void` | `setTopicAttributes(SetTopicAttributesRequest setTopicAttributesRequest)` The SetTopicAttributes action allows a topic owner to set an attribute of the topic to a new value.
`SubscribeResult` | `subscribe(SubscribeRequest subscribeRequest)` The Subscribe action prepares to subscribe an endpoint by sending the endpoint a confirmation message.
`void` | `unsubscribe(UnsubscribeRequest unsubscribeRequest)` The Unsubscribe action deletes a subscription.

Methods inherited from class com.amazonaws.AmazonWebServiceClient
`setEndpoint, shutdown`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.amazonaws.services.sns.AmazonSNS
`setEndpoint, shutdown`

Constructor Detail

### AmazonSNSClient

    public AmazonSNSClient(AWSCredentials awsCredentials)

  Constructs a new client to invoke service methods on AmazonSNS using the specified AWS account credentials.

  All service calls made using this new client object are blocking, and will not return until the service call completes.

  Parameters:
    `awsCredentials` - The AWS credentials (access key ID and secret key) to use when authenticating with AWS services.

### AmazonSNSClient

    public AmazonSNSClient(AWSCredentials awsCredentials,
                           ClientConfiguration clientConfiguration)

  Constructs a new client to invoke service methods on AmazonSNS using the specified AWS account credentials and client configuration options.

  All service calls made using this new client object are blocking, and will not return until the service call completes.

  Parameters:
    `awsCredentials` - The AWS credentials (access key ID and secret key) to use when authenticating with AWS services.
    `clientConfiguration` - The client configuration options controlling how this client connects to AmazonSNS (ex: proxy settings, retry counts, etc.).

Method Detail

### confirmSubscription

    public ConfirmSubscriptionResult confirmSubscription(ConfirmSubscriptionRequest confirmSubscriptionRequest)
                                                  throws AmazonServiceException,
                                                         AmazonClientException

  The ConfirmSubscription action verifies an endpoint owner's intent to receive messages by validating the token sent to the endpoint by an earlier Subscribe action. If the token is valid, the action creates a new subscription and returns its Amazon Resource Name (ARN). This call requires an AWS signature only when the AuthenticateOnUnsubscribe flag is set to "true".

  Specified by:
    `confirmSubscription` in interface `AmazonSNS`
  Parameters:
    `confirmSubscriptionRequest` - Container for the necessary parameters to execute the ConfirmSubscription service method on AmazonSNS.
  Returns:
    The response from the ConfirmSubscription service method, as returned by AmazonSNS.
  Throws:
    `NotFoundException`
    `AuthorizationErrorException`
    `InternalErrorException`
    `SubscriptionLimitExceededException`
    `InvalidParameterException`
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### getTopicAttributes

    public GetTopicAttributesResult getTopicAttributes(GetTopicAttributesRequest getTopicAttributesRequest)
                                                throws AmazonServiceException,
                                                       AmazonClientException

  The GetTopicAttribtues action returns all of the properties of a topic customers have created. Topic properties returned might differ based on the authorization of the user.

  Specified by:
    `getTopicAttributes` in interface `AmazonSNS`
  Parameters:
    `getTopicAttributesRequest` - Container for the necessary parameters to execute the GetTopicAttributes service method on AmazonSNS.
  Returns:
    The response from the GetTopicAttributes service method, as returned by AmazonSNS.
  Throws:
    `NotFoundException`
    `AuthorizationErrorException`
    `InternalErrorException`
    `InvalidParameterException`
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### subscribe

    public SubscribeResult subscribe(SubscribeRequest subscribeRequest)
                              throws AmazonServiceException,
                                     AmazonClientException

  The Subscribe action prepares to subscribe an endpoint by sending the endpoint a confirmation message. To actually create a subscription, the endpoint owner must call the ConfirmSubscription action with the token from the confirmation message. Confirmation tokens are valid for twenty-four hours.

  Specified by:
    `subscribe` in interface `AmazonSNS`
  Parameters:
    `subscribeRequest` - Container for the necessary parameters to execute the Subscribe service method on AmazonSNS.
  Returns:
    The response from the Subscribe service method, as returned by AmazonSNS.
  Throws:
    `NotFoundException`
    `AuthorizationErrorException`
    `InternalErrorException`
    `SubscriptionLimitExceededException`
    `InvalidParameterException`
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### setTopicAttributes

    public void setTopicAttributes(SetTopicAttributesRequest setTopicAttributesRequest)
                            throws AmazonServiceException,
                                   AmazonClientException

  The SetTopicAttributes action allows a topic owner to set an attribute of the topic to a new value.

  Specified by:
    `setTopicAttributes` in interface `AmazonSNS`
  Parameters:
    `setTopicAttributesRequest` - Container for the necessary parameters to execute the SetTopicAttributes service method on AmazonSNS.
  Throws:
    `NotFoundException`
    `AuthorizationErrorException`
    `InternalErrorException`
    `InvalidParameterException`
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### deleteTopic

    public void deleteTopic(DeleteTopicRequest deleteTopicRequest)
                     throws AmazonServiceException,
                            AmazonClientException

  The DeleteTopic action deletes a topic and all its subscriptions. Deleting a topic might prevent some messages previously sent to the topic from being delivered to subscribers. This action is idempotent, so deleting a topic that does not exist will not result in an error.

  Specified by:
    `deleteTopic` in interface `AmazonSNS`
  Parameters:
    `deleteTopicRequest` - Container for the necessary parameters to execute the DeleteTopic service method on AmazonSNS.
  Throws:
    `NotFoundException`
    `AuthorizationErrorException`
    `InternalErrorException`
    `InvalidParameterException`
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### removePermission

    public void removePermission(RemovePermissionRequest removePermissionRequest)
                          throws AmazonServiceException,
                                 AmazonClientException

  The RemovePermission action removes a statement from a topic's access control policy.

  Specified by:
    `removePermission` in interface `AmazonSNS`
  Parameters:
    `removePermissionRequest` - Container for the necessary parameters to execute the RemovePermission service method on AmazonSNS.
  Throws:
    `NotFoundException`
    `AuthorizationErrorException`
    `InternalErrorException`
    `InvalidParameterException`
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### listSubscriptions

    public ListSubscriptionsResult listSubscriptions(ListSubscriptionsRequest listSubscriptionsRequest)
                                              throws AmazonServiceException,
                                                     AmazonClientException

  The ListSubscriptions action returns a list of the requester's subscriptions. Each call returns a limited list of subscriptions. If there are more subscriptions, a NextToken is also returned. Use the NextToken parameter in a new ListSubscriptions call to get further results.

  Specified by:
    `listSubscriptions` in interface `AmazonSNS`
  Parameters:
    `listSubscriptionsRequest` - Container for the necessary parameters to execute the ListSubscriptions service method on AmazonSNS.
  Returns:
    The response from the ListSubscriptions service method, as returned by AmazonSNS.
  Throws:
    `AuthorizationErrorException`
    `InternalErrorException`
    `InvalidParameterException`
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### addPermission

    public void addPermission(AddPermissionRequest addPermissionRequest)
                       throws AmazonServiceException,
                              AmazonClientException

  The AddPermission action adds a statement to a topic's access control policy, granting access for the specified AWS accounts to the specified actions.

  Specified by:
    `addPermission` in interface `AmazonSNS`
  Parameters:
    `addPermissionRequest` - Container for the necessary parameters to execute the AddPermission service method on AmazonSNS.
  Throws:
    `NotFoundException`
    `AuthorizationErrorException`
    `InternalErrorException`
    `InvalidParameterException`
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### createTopic

    public CreateTopicResult createTopic(CreateTopicRequest createTopicRequest)
                                  throws AmazonServiceException,
                                         AmazonClientException

  The CreateTopic action creates a topic to which notifications can be published. Users can create at most 25 topics. This action is idempotent, so if the requester already owns a topic with the specified name, that topic's ARN will be returned without creating a new topic.

  Specified by:
    `createTopic` in interface `AmazonSNS`
  Parameters:
    `createTopicRequest` - Container for the necessary parameters to execute the CreateTopic service method on AmazonSNS.
  Returns:
    The response from the CreateTopic service method, as returned by AmazonSNS.
  Throws:
    `AuthorizationErrorException`
    `InternalErrorException`
    `InvalidParameterException`
    `TopicLimitExceededException`
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### listTopics

    public ListTopicsResult listTopics(ListTopicsRequest listTopicsRequest)
                                throws AmazonServiceException,
                                       AmazonClientException

  The ListTopics action returns a list of the requester's topics. Each call returns a limited list of topics. If there are more topics, a NextToken is also returned. Use the NextToken parameter in a new ListTopics call to get further results.

  Specified by:
    `listTopics` in interface `AmazonSNS`
  Parameters:
    `listTopicsRequest` - Container for the necessary parameters to execute the ListTopics service method on AmazonSNS.
  Returns:
    The response from the ListTopics service method, as returned by AmazonSNS.
  Throws:
    `AuthorizationErrorException`
    `InternalErrorException`
    `InvalidParameterException`
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### unsubscribe

    public void unsubscribe(UnsubscribeRequest unsubscribeRequest)
                     throws AmazonServiceException,
                            AmazonClientException

  The Unsubscribe action deletes a subscription. If the subscription requires authentication for deletion, only the owner of the subscription or the its topic's owner can unsubscribe, and an AWS signature is required. If the Unsubscribe call does not require authentication and the requester is not the subscription owner, a final cancellation message is delivered to the endpoint, so that the endpoint owner can easily resubscribe to the topic if the Unsubscribe request was unintended.

  Specified by:
    `unsubscribe` in interface `AmazonSNS`
  Parameters:
    `unsubscribeRequest` - Container for the necessary parameters to execute the Unsubscribe service method on AmazonSNS.
  Throws:
    `NotFoundException`
    `AuthorizationErrorException`
    `InternalErrorException`
    `InvalidParameterException`
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### listSubscriptionsByTopic

    public ListSubscriptionsByTopicResult listSubscriptionsByTopic(ListSubscriptionsByTopicRequest listSubscriptionsByTopicRequest)
                                                            throws AmazonServiceException,
                                                                   AmazonClientException

  The ListSubscriptionsByTopic action returns a list of the subscriptions to a specific topic. Each call returns a limited list of subscriptions. If there are more subscriptions, a NextToken is also returned. Use the NextToken parameter in a new ListSubscriptionsByTopic call to get further results.

  Specified by:
    `listSubscriptionsByTopic` in interface `AmazonSNS`
  Parameters:
    `listSubscriptionsByTopicRequest` - Container for the necessary parameters to execute the ListSubscriptionsByTopic service method on AmazonSNS.
  Returns:
    The response from the ListSubscriptionsByTopic service method, as returned by AmazonSNS.
  Throws:
    `NotFoundException`
    `AuthorizationErrorException`
    `InternalErrorException`
    `InvalidParameterException`
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### publish

    public PublishResult publish(PublishRequest publishRequest)
                          throws AmazonServiceException,
                                 AmazonClientException

  The Publish action sends a message to all of a topic's subscribed endpoints. When a messageId is returned, the message has been saved and Amazon SNS will attempt to deliver it to the topic's subscribers shortly. The format of the outgoing message to each subscribed endpoint depends on the notification protocol selected.

  Specified by:
    `publish` in interface `AmazonSNS`
  Parameters:
    `publishRequest` - Container for the necessary parameters to execute the Publish service method on AmazonSNS.
  Returns:
    The response from the Publish service method, as returned by AmazonSNS.
  Throws:
    `NotFoundException`
    `AuthorizationErrorException`
    `InternalErrorException`
    `InvalidParameterException`
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### listSubscriptions

    public ListSubscriptionsResult listSubscriptions()
                                              throws AmazonServiceException,
                                                     AmazonClientException

  The ListSubscriptions action returns a list of the requester's subscriptions. Each call returns a limited list of subscriptions. If there are more subscriptions, a NextToken is also returned. Use the NextToken parameter in a new ListSubscriptions call to get further results.

  Specified by:
    `listSubscriptions` in interface `AmazonSNS`
  Returns:
    The response from the ListSubscriptions service method, as returned by AmazonSNS.
  Throws:
    `AuthorizationErrorException`
    `InternalErrorException`
    `InvalidParameterException`
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### listTopics

    public ListTopicsResult listTopics()
                                throws AmazonServiceException,
                                       AmazonClientException

  The ListTopics action returns a list of the requester's topics. Each call returns a limited list of topics. If there are more topics, a NextToken is also returned. Use the NextToken parameter in a new ListTopics call to get further results.

  Specified by:
    `listTopics` in interface `AmazonSNS`
  Returns:
    The response from the ListTopics service method, as returned by AmazonSNS.
  Throws:
    `AuthorizationErrorException`
    `InternalErrorException`
    `InvalidParameterException`
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010 Amazon Web Services, Inc. All Rights Reserved.